org.h2.expression

## Class Wildcard

- java.lang.Object
- - org.h2.expression.Expression
  - - org.h2.expression.Wildcard

    public class Wildcard
    extends Expression

A wildcard expression as in SELECT * FROM TEST. This object is only used temporarily during the parsing phase, and later replaced by column expressions.

### Field Summary

### Fields inherited from class org.h2.expression.Expression

`MAP_IN_AGGREGATE, MAP_IN_WINDOW, MAP_INITIAL`

### Constructor Summary

Constructors
Constructor and Description
`Wildcard(java.lang.String schema, java.lang.String table)`

### Method Summary

Methods
`int` `getCost()` Estimate the cost to process the expression.
`java.util.ArrayList<ExpressionColumn>` `getExceptColumns()`
`java.lang.String` `getSchemaName()` Get the schema name, or null
`java.lang.StringBuilder` `getSQL(java.lang.StringBuilder builder, boolean alwaysQuote)` Appends the SQL statement of this expression to the specified builder.
`java.lang.String` `getTableAlias()` Get the table alias name or null if this expression does not represent a column.
`TypeInfo` `getType()` Returns the data type.
`Value` `getValue(Session session)` Return the resulting value for the current row.
`boolean` `isEverything(ExpressionVisitor visitor)` Check if this expression and all sub-expressions can fulfill a criteria.
`void` `mapColumns(ColumnResolver resolver, int level, int state)` Map the columns of the resolver to expression columns.
`java.util.HashMap<Column,ExpressionColumn>` `mapExceptColumns()` Returns map of excluded table columns to expression columns and validates that all columns are resolved and not duplicated.
`Expression` `optimize(Session session)` Try to optimize the expression.
`void` `setEvaluatable(TableFilter tableFilter, boolean b)` Tell the expression columns whether the table filter can return values now.
`void` `setExceptColumns(java.util.ArrayList<ExpressionColumn> exceptColumns)`
`void` `updateAggregate(Session session, int stage)` Update an aggregate value.

### Methods inherited from class org.h2.expression.Expression

`addFilterConditions, createIndexConditions, getAlias, getBooleanValue, getColumnName, getExpressionColumns, getExpressionColumns, getExpressionColumns, getNonAliasExpression, getNotIfPossible, getNullable, getSQL, getSubexpression, getSubexpressionCount, getTableName, getUnenclosedSQL, isAutoIncrement, isConstant, isGeneratedKey, isValueSet, toString, writeExpressions, writeExpressions`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### Wildcard

    public Wildcard(java.lang.String schema,
            java.lang.String table)

### Method Detail

#### getExceptColumns

    public java.util.ArrayList<ExpressionColumn> getExceptColumns()

#### setExceptColumns

    public void setExceptColumns(java.util.ArrayList<ExpressionColumn> exceptColumns)

#### mapExceptColumns

    public java.util.HashMap<Column,ExpressionColumn> mapExceptColumns()

Returns map of excluded table columns to expression columns and validates that all columns are resolved and not duplicated.

Returns:
  map of excluded table columns to expression columns

#### getValue

    public Value getValue(Session session)

Description copied from class: `Expression`
Return the resulting value for the current row.

Specified by:
  `getValue` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the result

#### getType

    public TypeInfo getType()

Description copied from class: `Expression`
Returns the data type. The data type may not be known before the optimization phase.

Specified by:
  `getType` in class `Expression`
Returns:
  the data type

#### mapColumns

    public void mapColumns(ColumnResolver resolver,
                  int level,
                  int state)

Description copied from class: `Expression`
Map the columns of the resolver to expression columns.

Specified by:
  `mapColumns` in class `Expression`
Parameters:
  `resolver` - the column resolver
  `level` - the subquery nesting level
  `state` - current state for nesting checks, initial value is `Expression.MAP_INITIAL`

#### optimize

    public Expression optimize(Session session)

Description copied from class: `Expression`
Try to optimize the expression.

Specified by:
  `optimize` in class `Expression`
Parameters:
  `session` - the session
Returns:
  the optimized expression

#### setEvaluatable

    public void setEvaluatable(TableFilter tableFilter,
                      boolean b)

Description copied from class: `Expression`
Tell the expression columns whether the table filter can return values now. This is used when optimizing the query.

Specified by:
  `setEvaluatable` in class `Expression`
Parameters:
  `tableFilter` - the table filter
  `b` - true if the table filter can return value

#### getTableAlias

    public java.lang.String getTableAlias()

Description copied from class: `Expression`
Get the table alias name or null if this expression does not represent a column.

Overrides:
  `getTableAlias` in class `Expression`
Returns:
  the table alias name

#### getSchemaName

    public java.lang.String getSchemaName()

Description copied from class: `Expression`
Get the schema name, or null

Overrides:
  `getSchemaName` in class `Expression`
Returns:
  the schema name

#### getSQL

    public java.lang.StringBuilder getSQL(java.lang.StringBuilder builder,
                                 boolean alwaysQuote)

Description copied from class: `Expression`
Appends the SQL statement of this expression to the specified builder. This may not always be the original SQL statement, specially after optimization.

Specified by:
  `getSQL` in class `Expression`
Parameters:
  `builder` - string builder
  `alwaysQuote` - quote all identifiers
Returns:
  the specified string builder

#### updateAggregate

    public void updateAggregate(Session session,
                       int stage)

Description copied from class: `Expression`
Update an aggregate value. This method is called at statement execution time. It is usually called once for each row, but if the expression is used multiple times (for example in the column list, and as part of the HAVING expression) it is called multiple times - the row counter needs to be used to make sure the internal state is only updated once.

Specified by:
  `updateAggregate` in class `Expression`
Parameters:
  `session` - the session
  `stage` - select stage

#### isEverything

    public boolean isEverything(ExpressionVisitor visitor)

Description copied from class: `Expression`
Check if this expression and all sub-expressions can fulfill a criteria. If any part returns false, the result is false.

Specified by:
  `isEverything` in class `Expression`
Parameters:
  `visitor` - the visitor
Returns:
  if the criteria can be fulfilled

#### getCost

    public int getCost()

Description copied from class: `Expression`
Estimate the cost to process the expression. Used when optimizing the query, to calculate the query plan with the lowest estimated cost.

Specified by:
  `getCost` in class `Expression`
Returns:
  the estimated cost